//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  wiɉ摜\łTRicehEditR|[lg
//  TPicture^̃vpeB
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2014N1225 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plBackPictRichEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls, ComCtrls,
  Graphics, forms;

type
  TplBackPictRichEdit = class (TRichEdit)
  private
    procedure SetBackPicture(const Value: TPicture);
    procedure SetBackPictStretch(const Value: Boolean);
  protected
    FCanvas          : TControlCanvas;
    FBitmap          : TBitmap;
    FBackPicture     : TPicture;
    FBackPictStretch : Boolean;
    FBackPictFlag    : Boolean;
    procedure CreateWnd; override;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property BackPicture     : TPicture read FBackPicture     write SetBackPicture;
    property BackPictStretch : Boolean  read FBackPictStretch write SetBackPictStretch;
  published
  end;

procedure Register;

implementation

{ TplBackPictRichEdit }

//-----------------------------------------------------------------------------
//  R|[lg̃RXgN^
//  wiɉ摜`悷ۂɎgpTCanvas𐶐
//  ̉摜pTPictureIuWFNg𐶐
//-----------------------------------------------------------------------------
constructor TplBackPictRichEdit.Create(AOwner: TComponent);
begin
  inherited;
  FCanvas := TControlCanvas.Create;
  FBackPicture := TPicture.Create;
  FBackPictStretch := False;
  FBackPictFlag    := False;

  FBitmap := TBitmap.Create;
  FBitmap.Transparent := False;
end;

//-----------------------------------------------------------------------------
//  R|[lg̃fXgN^
//-----------------------------------------------------------------------------
destructor TplBackPictRichEdit.Destroy;
begin
  FBitmap.Free;
  FBackPicture.Free;
  FCanvas.Free;
  inherited;
end;

//-----------------------------------------------------------------------------
//  CreateWnd
//  CreateWnd̓EBhE鎞Ɏs郁\bh
//-----------------------------------------------------------------------------
procedure TplBackPictRichEdit.CreateWnd;
var
  ExtStyle : Cardinal;
begin
  inherited;

  if not (csDesigning in ComponentState) then begin
    ExtStyle := GetWindowLong(Handle, GWL_EXSTYLE);
    if FBackPicture.Graphic = nil then begin
      SetWindowLong(Handle, GWL_EXSTYLE, ExtStyle and not WS_EX_TRANSPARENT);
    end else begin
      SetWindowLong(Handle, GWL_EXSTYLE, ExtStyle or WS_EX_TRANSPARENT);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  BackPicture(TPicture)vpeB̐ݒp\bh
//-----------------------------------------------------------------------------
procedure TplBackPictRichEdit.SetBackPicture(const Value: TPicture);
begin
  FBackPicture.Assign(Value);
  if not (csDesigning in ComponentState) then begin
    FBitmap.Assign(nil);
    if FBackPictStretch then begin
      FBitmap.SetSize(FBackPicture.Width, FBackPicture.Height);
    end else begin
      FBitmap.SetSize(Screen.Width, Screen.Height);
    end;
    FBitmap.Canvas.Brush.Color := Color;
    FBitmap.Canvas.FillRect(FBitmap.Canvas.ClipRect);
    FBitmap.Canvas.Draw(0, 0, FBackPicture.Graphic);

    FBackPictFlag := True;
    RecreateWnd;
  end;
end;

//-----------------------------------------------------------------------------
//  BackPictStretchvpeB̐ݒp\bh
//  Xgb`ŕ`悷邩C̃TCYŕ`悷邩̎w
//-----------------------------------------------------------------------------
procedure TplBackPictRichEdit.SetBackPictStretch(const Value: Boolean);
begin
  FBackPictStretch := Value;
  if not (csDesigning in ComponentState) then begin
    FBitmap.Assign(nil);
    if FBackPictStretch then begin
      FBitmap.SetSize(FBackPicture.Width, FBackPicture.Height);
    end else begin
      FBitmap.SetSize(Screen.Width, Screen.Height);
    end;
    FBitmap.Canvas.Brush.Color := Color;
    FBitmap.Canvas.FillRect(FBitmap.Canvas.ClipRect);
    FBitmap.Canvas.Draw(0, 0, FBackPicture.Graphic);

    FBackPictFlag := True;
    RecreateWnd;
  end;
end;

//-----------------------------------------------------------------------------
//  WM_ERASEBKGNDbZ[W
//  [W̍XVKvȗ̈XVC摜`悷
//  ̏̂߁CDoubleBufferedTrueɂƃeLXgɕ\Ȃ
//
//  wihׂĂ摜`悷ΓȂȂ
//  ƁC摜łCeLXg̕ҏWŃeLXg̕`悪Ȃ
//  CXN[̍ۂɉ摜`ꍇ
//  ŁC炩߉摜`悵rbg}bv\悤ɂĂ
//-----------------------------------------------------------------------------
procedure TplBackPictRichEdit.WMEraseBkgnd(var Message: TWMEraseBkgnd);
var
  LRect      : TRect;
  Rgn        : HRGN;
  ToBeErased : Boolean;
  Flags : Cardinal;
begin
  if (FBackPicture.Graphic = nil) and (csDesigning in ComponentState) then begin
    inherited;
    exit;
  end;

  FCanvas.Handle := Message.DC;
  Message.Result := 1;

  //XVKvȃ[W̍ŏ`̈̎擾
  ToBeErased := False;
  if not GetUpdateRect(Handle, LRect, ToBeErased) then begin
    LRect := Rect(0, 0, ClientWidth, ClientHeight);
  end;
  Rgn := CreateRectRgn(LRect.Left, LRect.Top, LRect.Right, LRect.Bottom);
  SelectClipRgn(FCanvas.Handle, Rgn);

  if FBackPictStretch then begin
    FCanvas.StretchDraw(ClientRect, FBitmap);
  end else begin
    FCanvas.Draw(0, 0, FBitmap);
  end;

  //RDW_FRAMEw肵ĔNCAg̈ĕ`
  //摜ςɁC1񂽂s
  if (FBackPictFlag) and Visible then begin
    FBackPictFlag := False;
    Flags := RDW_ERASE or RDW_INVALIDATE or RDW_FRAME;
    RedrawWindow(Handle, nil, 0, Flags);
  end;
end;

//-----------------------------------------------------------------------------
//  R|[lgo^
//-----------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('plXRAY', [TplBackPictRichEdit]);
end;

end.
